/* yasep/ASM/YASMed.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org

created 2009-01-23 by yg@yasep.org as tools/listed.js
2009-01-26
2009-01-31
2009-02-01
2009-02-06 : moved most code to the listed object
2009-02-10 : style changes, feedback from St<E9>phane Moriaux etc.
Feb 12 01:07:16 2009 : style changes again
Feb 16 02:34:50 2009
todo : gestion des <E9>v<E9>nements avec seamonkey : souris qui d<E9>tecte pas le rel<E2>chement du bouton
Feb 24 01:30:28 2009 : j'ai 32 ans ! et j'ai r<E9>uni les 2 images de la poubelle en une [:kikiv]
2009-07-07 : moved to tools/
2009-07-11 : new argument to ygwm.new_window
2009-07-22 : column hiding
2009-07-27 : duplicate_listing_row fixed
lun. févr. 13 04:59:42 CET 2012 : YASMed.js
lun. févr. 20 07:07:42 CET 2012 : export VHDL
sam. mars 24 14:01:02 CET 2012 : substitute
jeu. mai 10 04:44:20 CEST 2012 : moved from tool to ASM
mer. août 22 18:33:22 CEST 2012 : adding .org and ErrorLine
jeu. août 23 14:28:47 CEST 2012 : removing some global variables from win and using closures in win.asmctx functions
mar. août 28 01:20:11 CEST 2012 : some cleanup, checking instruction alignment, removing t.error and ErrorLine, making .org more functional, drag&drop of individual lines

Purpose : Create and maintain windows of the iterative assembly editor (derived from listed)

TODO : cleanup the trigger
DONE : prevent export if errors
TODO : better support for CPU profiles
 */

init_obj.push(YASMed={
  header: ";;;;;;;;;;;;;;; end auto header ;;;;;;;;;;;;;;;",

  serial:0,  // must be set by a cookie !!!

  OddEvenArray:["even", "odd"],

  AdjustPClen:function(win){
    if (win.asmctx.name!="" && win.asmctx.core===false && config.core) {
      var t=win.LastAddress,
          i=0;
      while (t>0){ // iterative log2
        i++;
        t>>>=1;
      }
      config.core.PC_length=i;
    }
  },

  reassemble:function(ev, win) {
    if (!win)
      win=this;
    win=ygwm.getParent(win);
    w=impASM.importCode(YASMed.export_ASM(-1,win));
    // overlay the new window over the current one ?
    ygwm.changeDimensions(win.w,win.h,w);
    w.move(win.x, win.y);
  },

  export_ASM:function(ev, win) {
    // if ev==-1 then just return the original source code (see reassemble)
    if (!win)
      win=this;
    if (win=ygwm.getParent(win)) {
      // ok now we have the window. let's generate a header for the new source code
      var h="; "+win.FuncName+generated(";","ASM/YASMed.js"),
          t= win.list_header_id.nextSibling, i,j="";
      if (win.subst.length>0) {
        h+="; Dump of the substitution table :\n";
        for (i in win.subst)
          h+=".subst "+win.subst[i].src+" "+win.subst[i].dst+"\n";
      }
      h+="; Nothing written above this line will be saved.\n"+YASMed.header+"\n";

      // now scan the original window and concatenate all the source code.
      while(t) {
        j+=t.source_id.source+"\n";
        if (t.source_id.source==YASMed.header)
          j="";
        t=t.nextSibling;
      }
      YASMed.AdjustPClen(win);

      // commit
      if (ev===-1)
        return h+j;
      else
        savefile.save(win.FuncName+".yas",h+j);
    }
  },

  export_HEX:function(ev, win) {
    if (!win)
      win=this;
    if (win=ygwm.getParent(win)) {
      if (win.start_address)
        return alert("ORG not supported");
      // ok now we have the window. create a header :
      var h=";;yhx0\n;; Dump of "+win.FuncName+generated(";;","ASM/YASMed.js"),
          t= win.list_header_id.nextSibling, i;
      // scan the source code and extract the binary output :
      while(t) {
        if (t.bgCol)
          return alert("Can't export if the code contains error(s)");
        if(t.bytes)
          for(i in t.bytes_array)
            h+=int2hex( t.bytes_array[i],1,1,1)+" ";
        if(t.source_id.source!="")
          h+="; "+t.source_id.source+"\n";
        t=t.nextSibling;
      }
      YASMed.AdjustPClen(win);
      savefile.save(win.FuncName+".yhx",h);
    }
  },

  export_VHDL:function(ev, win) {
    if (!win)
      win=this;
    if (win=ygwm.getParent(win)) {
      if (win.LastAddress & 1)
        return alert("The number of bytes must be even");
      if (win.start_address)
        return alert("ORG not supported");
      if ((typeof win.asmctx.core == "object")
        &&(typeof win.asmctx.core.PC_length == "number")
        &&(win.LastAddress > (1 << win.asmctx.core.PC_length) ))
        return alert("Too many instructions, memory too small");

      var size=win.LastAddress>>1,
          t=win.list_header_id.nextSibling, i, j=0, k;
h="-- Dump of "+win.FuncName
+generated("--","ASM/YASMed.js")
+"Library work;\n"
+"    use work.yasep_definitions.all;\n"
+"    use work.yasep_utils.all;\n"
+"Library ieee;\n"
+"    use ieee.std_logic_1164.all;\n"
+"    use ieee.numeric_std.all;\n"
+"\n"
+"entity SynchRam16 is\n"
+" port(\n"
+"  clk, reset, en: in std_logic := '0';\n"
+"  NPC: in SLVAI;\n"
+"  RAM_out: out SLV16);\n"
+"end SynchRam16;\n"
+"\n"
+"architecture "+win.FuncName+" of SynchRam16 is\n"
+"  signal latched_addr : SLVAI := (SLVAI'range=>'0');\n"
+"  type RAM_array_type is array(0 to "+size+") of SLV16;\n"
+"  constant RAM_array : RAM_array_type := (\n";

      function emit_SLV16(s,k) { // This function handles the mask bits,
        var m='",';              // so it emits "-" when the bit is "don't care"
        for (i=16; i>0; i--) {
          if (k & 1)
            m=(s & 1)+m;
          else
            m='-'+m;
          s>>>=1;
          k>>>=1;
        }
        h+=' "'+ m;
      }

      // Scan the source code and emit the bits
      while(t) {
        if (t.bgCol)
          return alert("Can't export if the code contains error(s)");
        if(t.bytes) {
          // is it an instruction ?
          if (t.encoded_fields!=0) {
            if (j  // some DB was not completely flushed
               ||(t.address & 1))
              return alert("line #"+t.TrLineNr+": instruction is not aligned on an even address");
            emit_SLV16(t.encoded_instruction, t.encoded_fields);
            if (t.bytes > 2)
              emit_SLV16(t.encoded_instruction >>> 16, t.encoded_fields >>> 16);
          }
          else {
            for(i in t.bytes_array) {
              var s=toBin(t.bytes_array[i],8);
              // accumulate 2 successive strings of 8 bits to make a 16-bits word
              // (note: j is initialised to 0 at the beginning of the function)
              if (!j++) // (j++==0)  OOoohh ugly...
                k=s;
              else {
                j=0;
                h+=' "'+s+k+'",';
              }
            }
          }
        }
        if(t.source_id.source!="")
          h+=" -- "+t.source_id.source+"\n";
        t=t.nextSibling;
      }

      YASMed.AdjustPClen(win);

h+=" \"1111111111111111\" );\n"  // Add "INV" because I wouldn't bother removing the last comma, plus the auto-prefetch gets the next word !
+"\n"
+"begin\n"
+"  process(clk, en)\n"
+"  begin\n"
+"    if rising_edge(clk) and en='0' then\n"
+"      latched_addr <= NPC;\n"
+"    end if;\n"
+"  end process;\n"
+"\n"
+"  process(latched_addr ,reset)\n"
+"    variable adr: integer;\n"
+"  begin\n"
+"    if reset/='1' then\n"
+"      RAM_out <= (RAM_out'range=>'0');\n"
+"    else\n"
+"      adr := safe_to_integer(latched_addr);\n"
+"      if adr < 0 or adr >= RAM_array'length then\n"
+"        report \" Accessing instruction beyond limit at \" & integer'image(adr);\n"
+"        RAM_out <= (RAM_out'range=>'1');\n"
+"      else\n"
+"        RAM_out <= RAM_array(adr);\n"
+"      end if;\n"
+"    end if;\n"
+"  end process;\n"
+"end "+win.FuncName+";\n";
      savefile.save(win.FuncName+".vhdl",h);
    }
  },

  //////////////////////////////////////////////////////
  // cleanup a table, remove any #text node inbetween the TR TH and TDs
  // (proved to be necessary......)
  cleanup_table:function(tbody_id) {
    var t=tbody_id.firstChild, tr, td, td2;   /// !!!!
    // scan the tbody
    while (t) {
      // preload the next sibling because we might remove t
      tr=t.nextSibling;
      if (t.nodeName!="TR")
        tbody_id.removeChild(t);
      else {
        // recurse : scan the TD/TH
        td = t.firstChild;
        while (td != null) {
          td2=td.nextSibling;
          if ((td.nodeName!="TD")&&(td.nodeName!="TH"))
            t.removeChild(td);
          td=td2;
        }
      }
      t=tr;
    }
  },

  // called by AssembleLine and duplicate_listing_row
  // and actually changes TR colors
  // Also catches unaligned instructions
  renumber_lines:function(win,t,n,ad) {
    // param #2 : id of the first TR to modify
    // param #3 : its intended line number;
    // param #4 : byte address

    // if only win is provided, renumber everything :
    if (!t) {
      t=win.list_header_id.nextSibling;
      n=0;
      ad=win.start_address;
    }

    var p=t.parentNode, org=-1;

    while (t != null) {
      var u=t.bgCol;
      if (t.org>=0)
        org++;
      // Check instruction alignment :
      if ((u==="")||(u=="unaligned")) { // don't touch other errors
        u="unaligned";
        if (t.encoded_fields && (ad&1))  // unaligned opcode
          win.shortmsg("Error : "+"unaligned instructions");
        else
          if((t.org>=0)&& org)
            win.shortmsg("Error : "+"only one .org allowed");
          else
            if ((t.org>=0)&&((ad!=win.start_address)||(ad!=t.org)))  // Catch .org at wrong line(s)
              win.shortmsg("Error : "+"invalid .org directive");
            else 
              u=""; // no error

        t.bgCol=u;
      }
      if (!u)
        u=YASMed.OddEvenArray[n & 1]; // if no error, update the background color
      t.className=u;

      t.numero_id.innerHTML  // create/update the numbers
        = t.TrLineNr
        = n++;

      t.address=ad;

      if (t.bytes>0){
        t.address_id.innerHTML=ad;
        ad+=t.bytes;
      }
      else
        t.address_id.innerHTML="";
      t=t.nextSibling; // go to the next element
    }

    // if the end of the list is reached,
    if (t == null) {
      p.nbElements=n; // update the element count.
      win.LastAddress_id.innerHTML
       =win.LastAddress
         =ad;
    }
  },

  Reassemble_line: function(t){
    var u=t.parentNode;
    YASMed.AssembleLine(ygwm.getParent(u),
      u, t.source, u.TrLineNr, u.address);
  },

  MakeRow: function(c) {
    var i,j,k, t=document.createElement("TR");
    t.onmouseover=YASMed.mouseover_row;
    for (i in c){
      j=document.createElement("TD");
      k=c[i];
      t[k+'_id']=j;
      j.className=k;
      switch(k) {
        case "plus" :
          j.title="add a new line";
          j.onclick=YASMed.duplicate_listing_row; // adapter plus tard
          break;
        case "numero" :
          j.title="move up/down or to trash";
          dragndrop.register(j, YASMed.dndRow, t);
          break;
        case "source":
          edit_text.register(j,
            { size:60, maxsize:200, func:YASMed.Reassemble_line });
      }
      t.appendChild(j);
    }
    return t;
  },

//  NewSym: function(win,s) {
//    return YASMed.MakeRow(["numero","symval","symname","symtype", "symcomm","symdef","symused"]);
//  },


// Called by NewLine, click->Reassemble_line, FirstLine, duplicate_listing_row
  AssembleLine: function(win, t, s, n, ad) {
// win : window
// t : tr / row of the table
// s : source code
// n : line number
// ad : address of the instruction's first byte
// Returns : nothing...

    t.bgCol
      =t.message_id.innerHTML
      =t.value_id.innerHTML
      =t.size_id.innerHTML
      ="";
    t.source_id.source=s;
    t.source_id.innerHTML=s.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;");
    t.bytes_array=[];
    t.org=-1;
    t.bytes
      =0;

//// À modifier !!!!!!!!!!!!
    for (var i in win.subst)
      s = s.replace(win.subst[i].rx, win.subst[i].dst);

    function add_message(col,msg){  // message display routine with closure
      t.message_id.innerHTML +='<span style="background-color:'+col+'">&nbsp;</span> '+msg+'<br>';
      if((col=="red")
       ||((col=="orange")&&(t.bgCol!="red")))
        t.bgCol=col;
    }
    win.asmctx.add_message=add_message;

    win.asmctx.emit_bin=
      function(data, size){
        var h="";
        while (size--) { // displays every byte
          t.bytes_array.push(data&255);
          h=int2hex(data&255,1,1,1)+h;
          data>>=8;
        }
        t.value_id.innerHTML+=h+" ";
      };

    if (s.length>0 && s[0]==='.') {
      // preprocessor directive ? get the next word
      s=s.replace(/[;].*/,"");  // remove any trailing comment
      s=s.replace(/\s+/g," ");  // combine multiple spaces
      s=s.replace(/[ ]$/g,"");  // strip trailing garbage
      var i, s2=s.split(" ");

      function parse_parameter2() {
        if (s2.length!=2)
          return add_message("red",'wrong directive format');

        s2=s2[1];
        if (s2.length > 30)
          return add_message("red",'please keep names shorter than 30 characters');

        // check for non alpha chars
        i=0;
        while (i < s2.length)
          if (alpha_chars[s2[i++]]!==1)
            return add_message("red",'<u>/!\\</u> contains a non-alpha character');
        return s2;
      }

      switch(s2[0]) {
        case ".name": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") break;

/// TODO: check that the new name is not already used ?

          // update the values
          ygwm.changeWinTitle(win, 
             win.name_id.innerHTML=
               win.FuncName=s,
            true);
          break;

        case ".org":
/* redundancy and position checks are relegated to renumber_lines */

          // check if it's a valid number
          s=parse_parameter2();
          i=str2int(s,"q"); // quiet : don't send an error message
          if ((i===null)||(i<0)) {
            add_message("red", 'Invalid number format '+s);
            break;
          }

          t.org
           =win.start_address_id.innerHTML
           =win.start_address
           =i;
          // force rescan from the beginning of the listing
          t=null;
          break; // trigger renumber_lines but renumber from the very start

        case ".profile": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") {
            add_message("red",'Bad profile name ?');
            break;
          }
          if (s=="auto") {
            t.message_id.innerHTML+='OK, generating the opcode map automatically';
            win.asmctx.core=false;
            break;
          }
          if (typeof profiles[s]!= "object") {
            add_message("red",'<b>This profile does not exist</b>');
            break;
          }
          win.asmctx.core=profiles[s];
          break;

        case ".": // alias for "label"
          s=parse_parameter2();
          if (typeof s!= "string") {
            add_message("red",'Bad label name ?');
            break;
          }
          if ((typeof (i=win.tsbus[s2[1]])=="number")&& (win.subst[i].dst!=ad)){
            t.message_id.innerHTML+='<b>same value, keeping the old definition</b>';
            break;
          }
          s2=[false,s,""+ad];
          // fold !

        case ".subst":
          if (s2.length<2) {
            add_message("red",'Missing word to substitute');
            break;
          }
          if (s2.length<3)
            t.message_id.innerHTML='/!\\ are you sure you really want to hide <i>this</i> word ?';

          var tr,dst="";
          i=2;
          while(i<s2.length) // ugly
            dst+=s2[i++]+" "; // concatenate the rest of the line

          (tr=document.createElement("DIV")).innerHTML="<b>"+s2[1].replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")
               +"</b> = \"<i>"+dst.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")+"\"</i>";
          var o={
            src:s2[1],
            dst:dst,
            rx:new RegExp(s2[1],"g"),
            tr:tr
          };
          win.subst_id.appendChild(tr);
          if (typeof (i=win.tsbus[s2[1]])=="number"){
            win.subst_id.removeChild(win.subst[i].tr);
            win.subst[i]=o;
          }
          else {
            win.tsbus[s2[1]]=win.subst.length;
            win.subst.push(o);
          }
          break;

        default: add_message("red",'<b>unknown directive</b>');
      }
    }
    else {
      Y.encode_instruction(s,win.asmctx);
      if (t.bytes=win.asmctx.encoded_size_bytes) {
        t.size_id.innerHTML=t.bytes;
        t.encoded_fields=win.asmctx.encoded_fields;
        t.encoded_instruction=win.asmctx.encoded_instruction;

        // add the instruction to the used list
        if (win.asmctx.name!="" && win.asmctx.core===false)
          config.changeInstruction("true",win.asmctx.name);
      }
    }

    YASMed.renumber_lines(win,t,n,ad);
  },

  listed_id:["plus","numero","address","size","value","source","message"],

  NewLine: function(win,s) {
    var t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.appendChild(t);
    YASMed.AssembleLine(win,t,s,win.listed_id.nbElements,win.LastAddress);
  },

  FirstLine: function(ev) {
    var win=ygwm.getParent(this),
        t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.insertBefore(t,win.list_header_id.nextSibling);
    YASMed.AssembleLine(win,t,"",0,win.start_address);
          // call NewLine instead ?
    return false;
  },

  duplicate_listing_row:function(ev) {
    // this is the id of the <td class="plus">
    var originalTR = this.parentNode,  // the TR
        p=originalTR.parentNode,       // The table
        win=ygwm.getParent(p);         // the window

    if (!ev.ctrlKey) { // Duplicate
      // new row:
      var newTR = YASMed.MakeRow(YASMed.listed_id);
      // include the new row in the table (which forces reflow and redraw)
      p.insertBefore(newTR,originalTR.nextSibling);
      YASMed.AssembleLine(win,newTR,
             ev.shiftKey?originalTR.source_id.source:"",
             originalTR.TrLineNr+1, originalTR.address+originalTR.bytes);
          // call NewLine instead ?
    }
    else  // Erase
      YASMed.remove_row(originalTR);
  },

  remove_row: function(tr){ // simple version, no dnd
    var p=ygwm.getParent(tr);
    tr.parentNode.removeChild(tr); // Attention j'enlève l'échelle
    YASMed.renumber_lines(p);
  },

///////////////////////////////////////////////////////////////////////////////////////////

// Drag&Drop of one TR into the same, or a different, listing

// generated by the following code :
//  moved_row_prev_index:null,
//  moved_row_newWin:null,
//  orig_win:null,
//  moved_row_prevSibling:null,

  trash_row: function(tr){
    tr.parentNode.removeChild(tr);
    // rescan everything
    YASMed.renumber_lines(YASMed.orig_win);
  },

  mousedrop_row:function() {
    if (YASMed.moved_row_newWin != YASMed.orig_win)
      YASMed.renumber_lines(YASMed.moved_row_newWin);
    YASMed.renumber_lines(YASMed.orig_win);
  },

  // When the mouse goes over a TR :
  mouseover_row:function(/*ev*/) {
    if ((dragndrop.dragdropstate ==6) && (this != dragndrop.moved_item)) {
      var  newIndex=this,    // "this" is the TR
             parent=this.parentNode,
                win=ygwm.getParent(parent);

      // move a row within the same table ?
      if (YASMed.moved_row_newWin == win) {
        // evaluate where it's better to put the row...
        if ((this.TrLineNr  > YASMed.moved_row_prev_index)
        || ((this.TrLineNr == YASMed.moved_row_prev_index)
             &&(this.previousSibling==dragndrop.moved_item)))
          newIndex=this.nextSibling;
      }
      // move from another table/window :
      else  // focus and update moved_row_newWin
        ygwm.focus_window(null,
          YASMed.moved_row_newWin
          =win);

      dragndrop.moved_item=parent.insertBefore(dragndrop.moved_item,newIndex);
      YASMed.moved_row_prev_index = this.TrLineNr;
      return false;
    }
    return true;
  },

  // onmousedown : called by the dnd register function (start_move => this.dnd.ondrag(this.dndroot); )
  start_move_row:function(row) {
    YASMed.orig_win
     =YASMed.moved_row_newWin
     =ygwm.getParent(row);
    YASMed.moved_row_prev_index=row.TrLineNr;
    YASMed.moved_row_prevSibling=row.previousSibling;  // there is ALWAYS a previous sibling (the header or colgroups)
    row.className="selected";  // highlight / change the display style
  },

///////////////////////////////////////////////////////////////////////////////////////////

  // Create a new editor window
  start: function() {
    var plus, win, f="function"+YASMed.serial++,
      cont=document.createElement("DIV");
    cont.innerHTML=import_htmi("ASM/YASMed");
    winman.patchInnerLinks(cont);
    win = ygwm.new_window("YASMed "+f, null, cont,
       600, 450, 120, 60, false, true, true, true, false, "doc_cygr");
    YASMed.cleanup_table(win.listed_id=getByClass("table_listing","TBODY",cont));
    win.list_header_id=getById("list_header","tr",cont);
    win.listed_id.nbElements=0;
    getById("export_asm" ,"input",win).onclick=YASMed.export_ASM;
    getById("export_hex" ,"input",win).onclick=YASMed.export_HEX;
    getById("export_vhdl","input",win).onclick=YASMed.export_VHDL;
    getById("reassemble" ,"input",win).onclick=YASMed.reassemble;
    (plus=getByClass("plus","th",win.list_header_id)).onclick=YASMed.FirstLine;

    // update the listing name :
    (win.name_id=getByClass("block_name","SPAN",win)).innerHTML=(win.FuncName=f);
    edit_text.register(win.name_id, { size:40,
       func: function(t){ win.FuncName=t.source },
       check: edit_text.filter_alpha });

    (win.start_address_id=getByClass("start_address","SPAN",win)).innerHTML=  win.start_address=
     (win.LastAddress_id =getByClass("last_address", "SPAN",win)).innerHTML=  win.LastAddress=   0;

    win.asmctx=new Y.ASM_context(null, null, true);

    win.subst=[];
    win.tsbus=[]; // reverse substitution
    win.subst_id=getByClass("subst","DIV",win);

    return win;
  },

  init_obj: function(){
    YASMed.dndRow={
      trashBin:true,
      ondelete:YASMed.trash_row,
      ondrag:YASMed.start_move_row,
      ondrop:YASMed.mousedrop_row,
      state:6
    };

    menu.subMenuItem(menu.list["ASM"], ["New&nbsp;editor", "Nouvel&nbsp;éditeur"], "ASM/YASMed");
  }
});
